import * as tslib_1 from "tslib";
import { ComponentFactoryResolver, Directive, ElementRef, Input, Renderer2, ViewContainerRef, } from "@angular/core";
import { environment } from "@environments/environment";
import { SharedAbstractSpinnerDirective } from "@shared/directives/shared-abstract-spinner/shared-abstract-spinner.directive";
import { isNullOrUndefined, isTrue, } from "solidify-frontend";
var SharedSpinnerDirective = /** @class */ (function (_super) {
    tslib_1.__extends(SharedSpinnerDirective, _super);
    function SharedSpinnerDirective(_elementRef, _renderer, _viewContainerRef, _componentFactoryResolver) {
        var _this = _super.call(this, _elementRef, _renderer, _viewContainerRef, _componentFactoryResolver, "spinner-background") || this;
        _this._elementRef = _elementRef;
        _this._renderer = _renderer;
        _this._viewContainerRef = _viewContainerRef;
        _this._componentFactoryResolver = _componentFactoryResolver;
        _this.strokeWidth = environment.defaultSpinnerStrokeWidth;
        _this.diameter = environment.defaultSpinnerDiameter;
        return _this;
    }
    Object.defineProperty(SharedSpinnerDirective.prototype, "show", {
        set: function (value) {
            if (isNullOrUndefined(value)) {
                console.warn("dlcmSpinner directive received a null or undefined value");
                value = true;
            }
            this._show = value;
            if (!this._isReady) {
                return;
            }
            if (isTrue(this._show)) {
                this._renderer.appendChild(this._elementRef.nativeElement, this.spinnerWrapper);
            }
            else {
                this._renderer.removeChild(this._elementRef.nativeElement, this.spinnerWrapper);
            }
        },
        enumerable: true,
        configurable: true
    });
    SharedSpinnerDirective.prototype.ngOnInit = function () {
        _super.prototype.ngOnInit.call(this);
    };
    tslib_1.__decorate([
        Input("dlcmSpinner"),
        tslib_1.__metadata("design:type", Boolean),
        tslib_1.__metadata("design:paramtypes", [Boolean])
    ], SharedSpinnerDirective.prototype, "show", null);
    tslib_1.__decorate([
        Input("dlcmSpinnerStrokeWidth"),
        tslib_1.__metadata("design:type", Number)
    ], SharedSpinnerDirective.prototype, "strokeWidth", void 0);
    tslib_1.__decorate([
        Input("dlcmSpinnerDiameter"),
        tslib_1.__metadata("design:type", Number)
    ], SharedSpinnerDirective.prototype, "diameter", void 0);
    SharedSpinnerDirective = tslib_1.__decorate([
        Directive({
            selector: "[dlcmSpinner]",
        }),
        tslib_1.__metadata("design:paramtypes", [ElementRef,
            Renderer2,
            ViewContainerRef,
            ComponentFactoryResolver])
    ], SharedSpinnerDirective);
    return SharedSpinnerDirective;
}(SharedAbstractSpinnerDirective));
export { SharedSpinnerDirective };
//# sourceMappingURL=shared-spinner.directive.js.map