import {User} from "@models";
import {
  isEmptyString,
  isNotNullNorUndefined,
  isNullOrUndefined,
  StringUtil,
} from "solidify-frontend";

export class UserHelper {
  static extraInfoSecondLineLabelCallback: (user: User) => string = (user) => {
    let extraLabel = StringUtil.stringEmpty;
    if (isNullOrUndefined(user.person)) {
      return extraLabel;
    }
    if (isNotNullNorUndefined(user.person.institutions)) {
      extraLabel = user.person.institutions.join(", ");
    }
    if (user.lastName !== user.person.lastName || user.firstName !== user.person.firstName) {
      if (!isEmptyString(extraLabel)) {
        extraLabel += " - ";
      }
      extraLabel += user.person.lastName + " " + user.person.firstName;
    }
    return extraLabel;
  }
}
